diff -uNrw asterisk-1.8.19.0/main/astmm.c asterisk-1.8.20.0-rc1/main/astmm.c
--- asterisk-1.8.19.0/main/astmm.c	2012-09-08 01:05:21.000000000 +0200
+++ asterisk-1.8.20.0-rc1/main/astmm.c	2012-12-08 00:40:19.000000000 +0100
@@ -453,55 +899,512 @@
 		count += cur->count;
 		if (cur->cache_len) {
 			if (fn) {
-				ast_cli(a->fd, "%10d bytes (%10d cache) in %d allocations in function '%s' of '%s'\n", 
-					cur->len, cur->cache_len, cur->count, cur->fn, fn);
+				ast_cli(a->fd, "%10u bytes (%10u cache) in %10u allocations by %20s() line %5u of %s\n",
+					cur->len, cur->cache_len, cur->count, cur->name, cur->lineno, fn);
 			} else {
-				ast_cli(a->fd, "%10d bytes (%10d cache) in %d allocations in file '%s'\n", 
-					cur->len, cur->cache_len, cur->count, cur->fn);
+				ast_cli(a->fd, "%10u bytes (%10u cache) in %10u allocations in file %s\n",
+					cur->len, cur->cache_len, cur->count, cur->name);
 			}
 		} else {
 			if (fn) {
-				ast_cli(a->fd, "%10d bytes in %d allocations in function '%s' of '%s'\n", 
-					cur->len, cur->count, cur->fn, fn);
+				ast_cli(a->fd, "%10u bytes in %10u allocations by %20s() line %5u of %s\n",
+					cur->len, cur->count, cur->name, cur->lineno, fn);
 			} else {
-				ast_cli(a->fd, "%10d bytes in %d allocations in file '%s'\n", 
-					cur->len, cur->count, cur->fn);
+				ast_cli(a->fd, "%10u bytes in %10u allocations in file %s\n",
+					cur->len, cur->count, cur->name);
 			}
 		}
 	}
 
-	if (cache_len)
-		ast_cli(a->fd, "%d bytes allocated (%d in caches) in %d allocations\n", len, cache_len, count);
-	else
-		ast_cli(a->fd, "%d bytes allocated in %d allocations\n", len, count);
+	if (cache_len) {
+		ast_cli(a->fd, "%u bytes allocated (%u in caches) in %u allocations\n",
+			len, cache_len, count);
+	} else {
+		ast_cli(a->fd, "%u bytes allocated in %u allocations\n", len, count);
+	}
 
 	return CLI_SUCCESS;
 }
 
 static struct ast_cli_entry cli_memory[] = {
-	AST_CLI_DEFINE(handle_memory_show, "Display outstanding memory allocations"),
+	AST_CLI_DEFINE(handle_memory_atexit_list, "Enable memory allocations not freed at exit list."),
+	AST_CLI_DEFINE(handle_memory_atexit_summary, "Enable memory allocations not freed at exit summary."),
+	AST_CLI_DEFINE(handle_memory_show_allocations, "Display outstanding memory allocations"),
 	AST_CLI_DEFINE(handle_memory_show_summary, "Summarize outstanding memory allocations"),
 };
 
-void __ast_mm_init(void)
+AST_LIST_HEAD_NOLOCK(region_list, ast_region);
+
+/*!
+ * \internal
+ * \brief Convert the allocated regions hash table to a list.
+ *
+ * \param list Fill list with the allocated regions.
+ *
+ * \details
+ * Take all allocated regions from the regions[] and put them
+ * into the list.
+ *
+ * \note reglock must be locked before calling.
+ *
+ * \note This function is destructive to the regions[] lists.
+ *
+ * \return Length of list created.
+ */
+static size_t mm_atexit_hash_list(struct region_list *list)
+{
+	struct ast_region *reg;
+	size_t total_length;
+	int idx;
+
+	total_length = 0;
+	for (idx = 0; idx < ARRAY_LEN(regions); ++idx) {
+		while ((reg = regions[idx])) {
+			regions[idx] = AST_LIST_NEXT(reg, node);
+			AST_LIST_NEXT(reg, node) = NULL;
+			AST_LIST_INSERT_HEAD(list, reg, node);
+			++total_length;
+		}
+	}
+	return total_length;
+}
+
+/*!
+ * \internal
+ * \brief Put the regions list into the allocated regions hash table.
+ *
+ * \param list List to put into the allocated regions hash table.
+ *
+ * \note reglock must be locked before calling.
+ *
+ * \return Nothing
+ */
+static void mm_atexit_hash_restore(struct region_list *list)
 {
-	char filename[PATH_MAX];
-	size_t pad = sizeof(struct ast_region) - offsetof(struct ast_region, data);
+	struct ast_region *reg;
+	int hash;
+
+	while ((reg = AST_LIST_REMOVE_HEAD(list, node))) {
+		hash = HASH(reg->data);
+		AST_LIST_NEXT(reg, node) = regions[hash];
+		regions[hash] = reg;
+	}
+}
+
+/*!
+ * \internal
+ * \brief Sort regions comparision.
+ *
+ * \param left Region to compare.
+ * \param right Region to compare.
+ *
+ * \retval <0 if left < right
+ * \retval =0 if left == right
+ * \retval >0 if left > right
+ */
+static int mm_atexit_cmp(struct ast_region *left, struct ast_region *right)
+{
+	int cmp;
+	ptrdiff_t cmp_ptr;
+	ssize_t cmp_size;
+
+	/* Sort by filename. */
+	cmp = strcmp(left->file, right->file);
+	if (cmp) {
+		return cmp;
+	}
+
+	/* Sort by line number. */
+	cmp = left->lineno - right->lineno;
+	if (cmp) {
+		return cmp;
+	}
+
+	/* Sort by allocated size. */
+	cmp_size = left->len - right->len;
+	if (cmp_size) {
+		if (cmp_size < 0) {
+			return -1;
+		}
+		return 1;
+	}
+
+	/* Sort by allocated pointers just because. */
+	cmp_ptr = left->data - right->data;
+	if (cmp_ptr) {
+		if (cmp_ptr < 0) {
+			return -1;
+		}
+		return 1;
+	}
+
+	return 0;
+}
+
+/*!
+ * \internal
+ * \brief Merge the given sorted sublists into sorted order onto the end of the list.
+ *
+ * \param list Merge sublists onto this list.
+ * \param sub1 First sublist to merge.
+ * \param sub2 Second sublist to merge.
+ *
+ * \return Nothing
+ */
+static void mm_atexit_list_merge(struct region_list *list, struct region_list *sub1, struct region_list *sub2)
+{
+	struct ast_region *reg;
+
+	for (;;) {
+		if (AST_LIST_EMPTY(sub1)) {
+			/* The remaining sublist goes onto the list. */
+			AST_LIST_APPEND_LIST(list, sub2, node);
+			break;
+		}
+		if (AST_LIST_EMPTY(sub2)) {
+			/* The remaining sublist goes onto the list. */
+			AST_LIST_APPEND_LIST(list, sub1, node);
+			break;
+		}
+
+		if (mm_atexit_cmp(AST_LIST_FIRST(sub1), AST_LIST_FIRST(sub2)) <= 0) {
+			reg = AST_LIST_REMOVE_HEAD(sub1, node);
+		} else {
+			reg = AST_LIST_REMOVE_HEAD(sub2, node);
+		}
+		AST_LIST_INSERT_TAIL(list, reg, node);
+	}
+}
+
+/*!
+ * \internal
+ * \brief Take sublists off of the given list.
+ *
+ * \param list Source list to remove sublists from the beginning of list.
+ * \param sub Array of sublists to fill. (Lists are empty on entry.)
+ * \param num_lists Number of lists to remove from the source list.
+ * \param size Size of the sublists to remove.
+ * \param remaining Remaining number of elements on the source list.
+ *
+ * \return Nothing
+ */
+static void mm_atexit_list_split(struct region_list *list, struct region_list sub[], size_t num_lists, size_t size, size_t *remaining)
+{
+	int idx;
+
+	for (idx = 0; idx < num_lists; ++idx) {
+		size_t count;
+
+		if (*remaining < size) {
+			/* The remaining source list goes onto the sublist. */
+			AST_LIST_APPEND_LIST(&sub[idx], list, node);
+			*remaining = 0;
+			break;
+		}
+
+		/* Take a sublist off the beginning of the source list. */
+		*remaining -= size;
+		for (count = size; count--;) {
+			struct ast_region *reg;
+
+			reg = AST_LIST_REMOVE_HEAD(list, node);
+			AST_LIST_INSERT_TAIL(&sub[idx], reg, node);
+		}
+	}
+}
+
+/*!
+ * \internal
+ * \brief Sort the regions list using mergesort.
+ *
+ * \param list Allocated regions list to sort.
+ * \param length Length of the list.
+ *
+ * \return Nothing
+ */
+static void mm_atexit_list_sort(struct region_list *list, size_t length)
+{
+	/*! Semi-sorted merged list. */
+	struct region_list merged = AST_LIST_HEAD_NOLOCK_INIT_VALUE;
+	/*! Sublists to merge. (Can only merge two sublists at this time.) */
+	struct region_list sub[2] = {
+		AST_LIST_HEAD_NOLOCK_INIT_VALUE,
+		AST_LIST_HEAD_NOLOCK_INIT_VALUE
+	};
+	/*! Sublist size. */
+	size_t size = 1;
+	/*! Remaining elements in the list. */
+	size_t remaining;
+	/*! Number of sublist merge passes to process the list. */
+	int passes;
+
+	for (;;) {
+		remaining = length;
+
+		passes = 0;
+		while (!AST_LIST_EMPTY(list)) {
+			mm_atexit_list_split(list, sub, ARRAY_LEN(sub), size, &remaining);
+			mm_atexit_list_merge(&merged, &sub[0], &sub[1]);
+			++passes;
+		}
+		AST_LIST_APPEND_LIST(list, &merged, node);
+		if (passes <= 1) {
+			/* The list is now sorted. */
+			break;
+		}
+
+		/* Double the sublist size to remove for next round. */
+		size <<= 1;
+	}
+}
+
+/*!
+ * \internal
+ * \brief List all regions currently allocated.
+ *
+ * \param alloced regions list.
+ *
+ * \return Nothing
+ */
+static void mm_atexit_regions_list(struct region_list *alloced)
+{
+	struct ast_region *reg;
+
+	AST_LIST_TRAVERSE(alloced, reg, node) {
+		astmm_log("%s %s() line %u: %u bytes%s at %p\n",
+			reg->file, reg->func, reg->lineno,
+			(unsigned int) reg->len, reg->cache ? " (cache)" : "", reg->data);
+	}
+}
+
+/*!
+ * \internal
+ * \brief Summarize all regions currently allocated.
+ *
+ * \param alloced Sorted regions list.
+ *
+ * \return Nothing
+ */
+static void mm_atexit_regions_summary(struct region_list *alloced)
+{
+	struct ast_region *reg;
+	struct ast_region *next;
+	struct {
+		unsigned int count;
+		unsigned int len;
+		unsigned int cache_len;
+	} by_line, by_func, by_file, total;
+
+	by_line.count = 0;
+	by_line.len = 0;
+	by_line.cache_len = 0;
+
+	by_func.count = 0;
+	by_func.len = 0;
+	by_func.cache_len = 0;
+
+	by_file.count = 0;
+	by_file.len = 0;
+	by_file.cache_len = 0;
+
+	total.count = 0;
+	total.len = 0;
+	total.cache_len = 0;
+
+	AST_LIST_TRAVERSE(alloced, reg, node) {
+		next = AST_LIST_NEXT(reg, node);
+
+		++by_line.count;
+		by_line.len += reg->len;
+		if (reg->cache) {
+			by_line.cache_len += reg->len;
+		}
+		if (next && !strcmp(reg->file, next->file) && reg->lineno == next->lineno) {
+			continue;
+		}
+		if (atexit_summary & SUMMARY_BY_LINE) {
+			if (by_line.cache_len) {
+				astmm_log("%10u bytes (%u in caches) in %u allocations. %s %s() line %u\n",
+					by_line.len, by_line.cache_len, by_line.count, reg->file, reg->func, reg->lineno);
+			} else {
+				astmm_log("%10u bytes in %5u allocations. %s %s() line %u\n",
+					by_line.len, by_line.count, reg->file, reg->func, reg->lineno);
+			}
+		}
+
+		by_func.count += by_line.count;
+		by_func.len += by_line.len;
+		by_func.cache_len += by_line.cache_len;
+		by_line.count = 0;
+		by_line.len = 0;
+		by_line.cache_len = 0;
+		if (next && !strcmp(reg->file, next->file) && !strcmp(reg->func, next->func)) {
+			continue;
+		}
+		if (atexit_summary & SUMMARY_BY_FUNC) {
+			if (by_func.cache_len) {
+				astmm_log("%10u bytes (%u in caches) in %u allocations. %s %s()\n",
+					by_func.len, by_func.cache_len, by_func.count, reg->file, reg->func);
+			} else {
+				astmm_log("%10u bytes in %5u allocations. %s %s()\n",
+					by_func.len, by_func.count, reg->file, reg->func);
+			}
+		}
+
+		by_file.count += by_func.count;
+		by_file.len += by_func.len;
+		by_file.cache_len += by_func.cache_len;
+		by_func.count = 0;
+		by_func.len = 0;
+		by_func.cache_len = 0;
+		if (next && !strcmp(reg->file, next->file)) {
+			continue;
+		}
+		if (atexit_summary & SUMMARY_BY_FILE) {
+			if (by_file.cache_len) {
+				astmm_log("%10u bytes (%u in caches) in %u allocations. %s\n",
+					by_file.len, by_file.cache_len, by_file.count, reg->file);
+			} else {
+				astmm_log("%10u bytes in %5u allocations. %s\n",
+					by_file.len, by_file.count, reg->file);
+			}
+		}
+
+		total.count += by_file.count;
+		total.len += by_file.len;
+		total.cache_len += by_file.cache_len;
+		by_file.count = 0;
+		by_file.len = 0;
+		by_file.cache_len = 0;
+	}
+
+	if (total.cache_len) {
+		astmm_log("%u bytes (%u in caches) in %u allocations.\n",
+			total.len, total.cache_len, total.count);
+	} else {
+		astmm_log("%u bytes in %u allocations.\n", total.len, total.count);
+	}
+}
+
+/*!
+ * \internal
+ * \brief Dump the memory allocations atexit.
+ *
+ * \note reglock must be locked before calling.
+ *
+ * \return Nothing
+ */
+static void mm_atexit_dump(void)
+{
+	struct region_list alloced_atexit = AST_LIST_HEAD_NOLOCK_INIT_VALUE;
+	size_t length;
+
+	length = mm_atexit_hash_list(&alloced_atexit);
+	if (!length) {
+		/* Wow!  This is amazing! */
+		astmm_log("Exiting with all memory freed.\n");
+		return;
+	}
+
+	mm_atexit_list_sort(&alloced_atexit, length);
+
+	astmm_log("Exiting with the following memory not freed:\n");
+	if (atexit_list) {
+		mm_atexit_regions_list(&alloced_atexit);
+	}
+	if (atexit_summary) {
+		mm_atexit_regions_summary(&alloced_atexit);
+	}
+
+	/*
+	 * Put the alloced list back into regions[].
+	 *
+	 * We have do do this because we can get called before all other
+	 * threads have terminated.
+	 */
+	mm_atexit_hash_restore(&alloced_atexit);
+}
+
+/*!
+ * \internal
+ * \return Nothing
+ */
+static void mm_atexit_final(void)
+{
+	FILE *log;
+
+	/* Only wait if we want atexit allocation dumps. */
+	if (atexit_list || atexit_summary) {
+		fprintf(stderr, "Waiting 10 seconds to let other threads die.\n");
+		sleep(10);
+	}
+
+	regions_check_all_fences();
+
+	/* Flush all delayed memory free circular arrays. */
+	freed_regions_flush(&whales);
+	freed_regions_flush(&minnows);
+
+	/* Peform atexit allocation dumps. */
+	if (atexit_list || atexit_summary) {
+		ast_mutex_lock(&reglock);
+		mm_atexit_dump();
+		ast_mutex_unlock(&reglock);
+	}
 
-	if (pad) {
-		ast_log(LOG_ERROR, "struct ast_region has %d bytes of padding! This must be eliminated for low-fence checking to work properly!\n", (int) pad);
+	/* Close the log file. */
+	log = mmlog;
+	mmlog = NULL;
+	if (log) {
+		fclose(log);
+	}
 	}
 
+/*!
+ * \brief Initialize malloc debug phase 1.
+ *
+ * \note Must be called first thing in main().
+ *
+ * \return Nothing
+ */
+void __ast_mm_init_phase_1(void)
+{
+	atexit(mm_atexit_final);
+}
+
+/*!
+ * \internal
+ * \return Nothing
+ */
+static void mm_atexit_ast(void)
+{
+	ast_cli_unregister_multiple(cli_memory, ARRAY_LEN(cli_memory));
+}
+
+/*!
+ * \brief Initialize malloc debug phase 2.
+ *
+ * \return Nothing
+ */
+void __ast_mm_init_phase_2(void)
+{
+	char filename[PATH_MAX];
+
 	ast_cli_register_multiple(cli_memory, ARRAY_LEN(cli_memory));
 	
 	snprintf(filename, sizeof(filename), "%s/mmlog", ast_config_AST_LOG_DIR);
 	
 	ast_verb(1, "Asterisk Malloc Debugger Started (see %s))\n", filename);
 	
-	if ((mmlog = fopen(filename, "a+"))) {
+	mmlog = fopen(filename, "a+");
+	if (mmlog) {
 		fprintf(mmlog, "%ld - New session\n", (long)time(NULL));
 		fflush(mmlog);
+	} else {
+		ast_log(LOG_ERROR, "Could not open malloc debug log file: %s\n", filename);
 	}
+
+	ast_register_atexit(mm_atexit_ast);
 }
 
-#endif
+#endif	/* defined(__AST_DEBUG_MALLOC) */
diff -uNrw asterisk-1.8.19.0/main/ccss.c asterisk-1.8.20.0-rc1/main/ccss.c
--- asterisk-1.8.19.0/main/ccss.c	2012-11-02 21:48:03.000000000 +0100
+++ asterisk-1.8.20.0-rc1/main/ccss.c	2012-12-03 18:05:40.000000000 +0100
@@ -27,7 +27,7 @@
 
 #include "asterisk.h"
 
-ASTERISK_FILE_VERSION(__FILE__, "$Revision: 375658 $")
+ASTERISK_FILE_VERSION(__FILE__, "$Revision: 377037 $")
 
 #include "asterisk/astobj2.h"
 #include "asterisk/strings.h"
@@ -4317,6 +4317,8 @@
 	ast_cc_monitor_unregister(&generic_monitor_cbs);
 	ast_unregister_application(cccancel_app);
 	ast_unregister_application(ccreq_app);
+	ast_logger_unregister_level(CC_LOGGER_LEVEL_NAME);
+	ast_cli_unregister_multiple(cc_cli, ARRAY_LEN(cc_cli));
 
 	if (cc_sched_thread) {
 		cc_sched_thread = ast_sched_thread_destroy(cc_sched_thread);
diff -uNrw asterisk-1.8.19.0/main/cdr.c asterisk-1.8.20.0-rc1/main/cdr.c
--- asterisk-1.8.19.0/main/cdr.c	2012-11-04 00:44:30.000000000 +0100
+++ asterisk-1.8.20.0-rc1/main/cdr.c	2012-12-03 19:38:21.000000000 +0100
@@ -37,7 +37,7 @@
 
 #include "asterisk.h"
 
-ASTERISK_FILE_VERSION(__FILE__, "$Revision: 375727 $")
+ASTERISK_FILE_VERSION(__FILE__, "$Revision: 377069 $")
 
 #include <signal.h>
 
@@ -1481,7 +1481,7 @@
 static struct ast_cli_entry cli_submit = AST_CLI_DEFINE(handle_cli_submit, "Posts all pending batched CDR data");
 static struct ast_cli_entry cli_status = AST_CLI_DEFINE(handle_cli_status, "Display the CDR status");
 
-static int do_reload(int reload)
+static void do_reload(int reload)
 {
 	struct ast_config *config;
 	const char *enabled_value;
@@ -1497,11 +1497,10 @@
 	int cfg_time;
 	int was_enabled;
 	int was_batchmode;
-	int res=0;
 	struct ast_flags config_flags = { reload ? CONFIG_FLAG_FILEUNCHANGED : 0 };
 
 	if ((config = ast_config_load2("cdr.conf", "cdr", config_flags)) == CONFIG_STATUS_FILEUNCHANGED) {
-		return 0;
+		return;
 	}
 
 	ast_mutex_lock(&cdr_batch_lock);
@@ -1519,7 +1518,7 @@
 
 	if (config == CONFIG_STATUS_FILEMISSING || config == CONFIG_STATUS_FILEINVALID) {
 		ast_mutex_unlock(&cdr_batch_lock);
-		return 0;
+		return;
 	}
 
 	/* don't run the next scheduled CDR posting while reloading */
@@ -1582,7 +1581,6 @@
 		} else {
 			ast_cli_register(&cli_submit);
 			ast_register_atexit(ast_cdr_engine_term);
-			res = 0;
 		}
 	/* if this reload disabled the CDR and/or batch mode and there is a background thread,
 	   kill it */
@@ -1595,27 +1593,39 @@
 		ast_cond_destroy(&cdr_pending_cond);
 		ast_cli_unregister(&cli_submit);
 		ast_unregister_atexit(ast_cdr_engine_term);
-		res = 0;
 		/* if leaving batch mode, then post the CDRs in the batch,
 		   and don't reschedule, since we are stopping CDR logging */
 		if (!batchmode && was_batchmode) {
 			ast_cdr_engine_term();
 		}
-	} else {
-		res = 0;
 	}
 
 	ast_mutex_unlock(&cdr_batch_lock);
 	ast_config_destroy(config);
 	manager_event(EVENT_FLAG_SYSTEM, "Reload", "Module: CDR\r\nMessage: CDR subsystem reload requested\r\n");
+}
 
-	return res;
+static void cdr_engine_shutdown(void)
+{
+	if (cdr_thread != AST_PTHREADT_NULL) {
+		/* wake up the thread so it will exit */
+		pthread_cancel(cdr_thread);
+		pthread_kill(cdr_thread, SIGURG);
+		pthread_join(cdr_thread, NULL);
+		cdr_thread = AST_PTHREADT_NULL;
+		ast_cond_destroy(&cdr_pending_cond);
+	}
+	ast_cli_unregister(&cli_submit);
+
+	ast_cli_unregister(&cli_status);
+	sched_context_destroy(sched);
+	sched = NULL;
+	ast_free(batch);
+	batch = NULL;
 }
 
 int ast_cdr_engine_init(void)
 {
-	int res;
-
 	sched = sched_context_create();
 	if (!sched) {
 		ast_log(LOG_ERROR, "Unable to create schedule context.\n");
@@ -1623,15 +1633,10 @@
 	}
 
 	ast_cli_register(&cli_status);
+	do_reload(0);
+	ast_register_atexit(cdr_engine_shutdown);
 
-	res = do_reload(0);
-	if (res) {
-		ast_mutex_lock(&cdr_batch_lock);
-		res = init_batch();
-		ast_mutex_unlock(&cdr_batch_lock);
-	}
-
-	return res;
+	return 0;
 }
 
 /* \note This actually gets called a couple of times at shutdown.  Once, before we start
@@ -1643,7 +1648,8 @@
 
 int ast_cdr_engine_reload(void)
 {
-	return do_reload(1);
+	do_reload(1);
+	return 0;
 }
 
 int ast_cdr_data_add_structure(struct ast_data *tree, struct ast_cdr *cdr, int recur)
diff -uNrw asterisk-1.8.19.0/main/channel.c asterisk-1.8.20.0-rc1/main/channel.c
--- asterisk-1.8.19.0/main/channel.c	2012-11-05 23:50:21.000000000 +0100
+++ asterisk-1.8.20.0-rc1/main/channel.c	2012-11-13 19:10:22.000000000 +0100
@@ -29,7 +29,7 @@
 
 #include "asterisk.h"
 
-ASTERISK_FILE_VERSION(__FILE__, "$Revision: 375893 $")
+ASTERISK_FILE_VERSION(__FILE__, "$Revision: 376199 $")
 
 #include "asterisk/_private.h"
 
@@ -71,6 +71,7 @@
 #include "asterisk/stringfields.h"
 #include "asterisk/global_datastores.h"
 #include "asterisk/data.h"
+#include "asterisk/features.h"
 
 #ifdef HAVE_EPOLL
 #include <sys/epoll.h>
@@ -1836,11 +1837,13 @@
 }
 
 /*! \brief Wait, look for hangups and condition arg */
-int ast_safe_sleep_conditional(struct ast_channel *chan, int ms, int (*cond)(void*), void *data)
+int ast_safe_sleep_conditional(struct ast_channel *chan, int timeout_ms, int (*cond)(void*), void *data)
 {
 	struct ast_frame *f;
 	struct ast_silence_generator *silgen = NULL;
 	int res = 0;
+	struct timeval start;
+	int ms;
 	AST_LIST_HEAD_NOLOCK(, ast_frame) deferred_frames;
 
 	AST_LIST_HEAD_INIT_NOLOCK(&deferred_frames);
@@ -1850,8 +1853,10 @@
 		silgen = ast_channel_start_silence_generator(chan);
 	}
 
-	while (ms > 0) {
+	start = ast_tvnow();
+	while ((ms = ast_remaining_ms(start, timeout_ms))) {
 		struct ast_frame *dup_f = NULL;
+
 		if (cond && ((*cond)(data) == 0)) {
 			break;
 		}
@@ -2988,12 +2993,15 @@
 		do {
 			AST_LIST_HEAD_NOLOCK(, ast_frame) frames;
 			struct ast_frame *cur, *new;
-			int ms = MAX(delay, 500);
+			int timeout_ms = MAX(delay, 500);
 			unsigned int done = 0;
+			struct timeval start;
 
 			AST_LIST_HEAD_INIT_NOLOCK(&frames);
 
+			start = ast_tvnow();
 			for (;;) {
+				int ms = ast_remaining_ms(start, timeout_ms);
 				ms = ast_waitfor(chan, ms);
 				if (ms < 0) {
 					ast_log(LOG_WARNING, "Error condition occurred when polling channel %s for a voice frame: %s\n", chan->name, strerror(errno));
@@ -3110,7 +3118,11 @@
 
 	res = generate(chan, tmp, 0, ast_format_rate(chan->writeformat & AST_FORMAT_AUDIO_MASK) / 50);
 
+	ast_channel_lock(chan);
+        if (chan->generator && generate == chan->generator->generate) {
 	chan->generatordata = tmp;
+        }
+	ast_channel_unlock(chan);
 
 	if (res) {
 		ast_debug(1, "Auto-deactivating generator\n");
@@ -3508,11 +3520,14 @@
 
 int ast_waitfor(struct ast_channel *c, int ms)
 {
-	int oldms = ms;	/* -1 if no timeout */
-
+	if (ms < 0) {
+		do {
+			ms = 100000;
+			ast_waitfor_nandfds(&c, 1, NULL, 0, NULL, NULL, &ms);
+		} while (!ms);
+	} else {
 	ast_waitfor_nandfds(&c, 1, NULL, 0, NULL, NULL, &ms);
-	if ((ms < 0) && (oldms < 0))
-		ms = 0;
+	}
 	return ms;
 }
 
@@ -3567,6 +3582,7 @@
 int ast_waitfordigit_full(struct ast_channel *c, int timeout_ms, int audiofd, int cmdfd)
 {
 	struct timeval start = ast_tvnow();
+	int ms;
 
 	/* Stop if we're a zombie or need a soft hangup */
 	if (ast_test_flag(c, AST_FLAG_ZOMBIE) || ast_check_hangup(c))
@@ -3578,19 +3594,9 @@
 	/* Wait for a digit, no more than timeout_ms milliseconds total.
 	 * Or, wait indefinitely if timeout_ms is <0.
 	 */
-	while (ast_tvdiff_ms(ast_tvnow(), start) < timeout_ms || timeout_ms < 0) {
+	while ((ms = ast_remaining_ms(start, timeout_ms))) {
 		struct ast_channel *rchan;
 		int outfd=-1;
-		int ms;
-
-		if (timeout_ms < 0) {
-			ms = timeout_ms;
-		} else {
-			ms = timeout_ms - ast_tvdiff_ms(ast_tvnow(), start);
-			if (ms < 0) {
-				ms = 0;
-			}
-		}
 
 		errno = 0;
 		/* While ast_waitfor_nandfds tries to help by reducing the timeout by how much was waited,
@@ -4596,25 +4602,32 @@
 
 char *ast_recvtext(struct ast_channel *chan, int timeout)
 {
-	int res, done = 0;
+	int res;
 	char *buf = NULL;
+	struct timeval start = ast_tvnow();
+	int ms;
 	
-	while (!done) {
+	while ((ms = ast_remaining_ms(start, timeout))) {
 		struct ast_frame *f;
-		if (ast_check_hangup(chan))
+
+		if (ast_check_hangup(chan)) {
 			break;
-		res = ast_waitfor(chan, timeout);
-		if (res <= 0) /* timeout or error */
+		}
+		res = ast_waitfor(chan, ms);
+		if (res <= 0)  {/* timeout or error */
 			break;
-		timeout = res;	/* update timeout */
+		}
 		f = ast_read(chan);
-		if (f == NULL)
+		if (f == NULL) {
 			break; /* no frame */
-		if (f->frametype == AST_FRAME_CONTROL && f->subclass.integer == AST_CONTROL_HANGUP)
-			done = 1;	/* force a break */
-		else if (f->frametype == AST_FRAME_TEXT) {		/* what we want */
+		}
+		if (f->frametype == AST_FRAME_CONTROL && f->subclass.integer == AST_CONTROL_HANGUP) {
+			ast_frfree(f);
+			break;
+		} else if (f->frametype == AST_FRAME_TEXT) {		/* what we want */
 			buf = ast_strndup((char *) f->data.ptr, f->datalen);	/* dup and break */
-			done = 1;
+			ast_frfree(f);
+			break;
 		}
 		ast_frfree(f);
 	}
@@ -4665,6 +4678,11 @@
 	if (!chan->tech->send_digit_begin)
 		return 0;
 
+	ast_channel_lock(chan);
+	chan->sending_dtmf_digit = digit;
+	chan->sending_dtmf_tv = ast_tvnow();
+	ast_channel_unlock(chan);
+
 	if (!chan->tech->send_digit_begin(chan, digit))
 		return 0;
 
@@ -4688,6 +4706,12 @@
 {
 	int res = -1;
 
+	ast_channel_lock(chan);
+	if (chan->sending_dtmf_digit == digit) {
+		chan->sending_dtmf_digit = 0;
+	}
+	ast_channel_unlock(chan);
+
 	if (chan->tech->send_digit_end)
 		res = chan->tech->send_digit_end(chan, digit, duration);
 
@@ -5454,18 +5478,19 @@
 	if (ast_call(chan, data, 0)) {	/* ast_call failed... */
 		ast_log(LOG_NOTICE, "Unable to call channel %s/%s\n", type, (char *)data);
 	} else {
+		struct timeval start = ast_tvnow();
 		res = 1;	/* mark success in case chan->_state is already AST_STATE_UP */
 		while (timeout && chan->_state != AST_STATE_UP) {
 			struct ast_frame *f;
-			res = ast_waitfor(chan, timeout);
+			int ms = ast_remaining_ms(start, timeout);
+
+			res = ast_waitfor(chan, ms);
 			if (res == 0) { /* timeout, treat it like ringing */
 				*outstate = AST_CONTROL_RINGING;
 				break;
 			}
 			if (res < 0) /* error or done */
 				break;
-			if (timeout > -1)
-				timeout = res;
 			if (!ast_strlen_zero(chan->call_forward)) {
 				if (!(chan = ast_call_forward(NULL, chan, NULL, format, oh, outstate))) {
 					return NULL;
@@ -6495,6 +6520,8 @@
 	char orig[AST_CHANNEL_NAME];
 	char masqn[AST_CHANNEL_NAME];
 	char zombn[AST_CHANNEL_NAME];
+	char clone_sending_dtmf_digit;
+	struct timeval clone_sending_dtmf_tv;
 
 	/* XXX This operation is a bit odd.  We're essentially putting the guts of
 	 * the clone channel into the original channel.  Start by killing off the
@@ -6604,6 +6631,10 @@
 	free_translation(clonechan);
 	free_translation(original);
 
+	/* Save the current DTMF digit being sent if any. */
+	clone_sending_dtmf_digit = clonechan->sending_dtmf_digit;
+	clone_sending_dtmf_tv = clonechan->sending_dtmf_tv;
+
 	/* Save the original name */
 	ast_copy_string(orig, original->name, sizeof(orig));
 	/* Save the new name */
@@ -6848,6 +6879,15 @@
 
 	ast_channel_unlock(clonechan);
 
+	if (clone_sending_dtmf_digit) {
+		/*
+		 * The clonechan was sending a DTMF digit that was not completed
+		 * before the masquerade.
+		 */
+		ast_bridge_end_dtmf(original, clone_sending_dtmf_digit, clone_sending_dtmf_tv,
+			"masquerade");
+	}
+
 	/*
 	 * If an indication is currently playing, maintain it on the
 	 * channel that is taking the place of original.
@@ -8186,18 +8226,46 @@
 	return state;
 }
 
+static int internal_deactivate_generator(struct ast_channel *chan, void* generator)
+{
+	ast_channel_lock(chan);
+
+	if (!chan->generatordata) {
+		ast_debug(1, "Trying to stop silence generator when there is no "
+		    "generator on '%s'\n", chan->name);
+		ast_channel_unlock(chan);
+		return 0;
+	}
+	if (chan->generator != generator) {
+		ast_debug(1, "Trying to stop silence generator when it is not the current "
+		    "generator on '%s'\n", chan->name);
+		ast_channel_unlock(chan);
+		return 0;
+	}
+	if (chan->generator && chan->generator->release) {
+		chan->generator->release(chan, chan->generatordata);
+	}
+	chan->generatordata = NULL;
+	chan->generator = NULL;
+	ast_channel_set_fd(chan, AST_GENERATOR_FD, -1);
+	ast_clear_flag(chan, AST_FLAG_WRITE_INT);
+	ast_settimeout(chan, 0, NULL, NULL);
+	ast_channel_unlock(chan);
+
+	return 1;
+}
+
 void ast_channel_stop_silence_generator(struct ast_channel *chan, struct ast_silence_generator *state)
 {
 	if (!state)
 		return;
 
-	ast_deactivate_generator(chan);
-
+	if (internal_deactivate_generator(chan, &silence_generator)) {
 	ast_debug(1, "Stopped silence generator on '%s'\n", chan->name);
 
 	if (ast_set_write_format(chan, state->old_write_format) < 0)
 		ast_log(LOG_ERROR, "Could not return write format to its original state\n");
-
+	}
 	ast_free(state);
 }
 
diff -uNrw asterisk-1.8.19.0/main/cli.c asterisk-1.8.20.0-rc1/main/cli.c
--- asterisk-1.8.19.0/main/cli.c	2012-06-15 17:56:08.000000000 +0200
+++ asterisk-1.8.20.0-rc1/main/cli.c	2012-12-03 20:13:01.000000000 +0100
@@ -29,7 +29,7 @@
 
 #include "asterisk.h"
 
-ASTERISK_FILE_VERSION(__FILE__, "$Revision: 369001 $")
+ASTERISK_FILE_VERSION(__FILE__, "$Revision: 377073 $")
 
 #include "asterisk/_private.h"
 #include "asterisk/paths.h"	/* use ast_config_AST_MODULE_DIR */
@@ -1871,10 +1871,16 @@
 	return 0;
 }
 
+static void cli_shutdown(void)
+{
+	ast_cli_unregister_multiple(cli_cli, ARRAY_LEN(cli_cli));
+}
+
 /*! \brief initialize the _full_cmd string in * each of the builtins. */
 void ast_builtins_init(void)
 {
 	ast_cli_register_multiple(cli_cli, ARRAY_LEN(cli_cli));
+	ast_register_atexit(cli_shutdown);
 }
 
 /*!
@@ -2039,6 +2045,18 @@
 	return cmdline;
 }
 
+static int cli_is_registered(struct ast_cli_entry *e)
+{
+	struct ast_cli_entry *cur = NULL;
+
+	while ((cur = cli_next(cur))) {
+		if (cur == e) {
+			return 1;
+		}
+	}
+	return 0;
+}
+
 static int __ast_cli_unregister(struct ast_cli_entry *e, struct ast_cli_entry *ed)
 {
 	if (e->inuse) {
@@ -2070,6 +2088,15 @@
 	char **dst = (char **)e->cmda;	/* need to cast as the entry is readonly */
 	char *s;
 
+	AST_RWLIST_WRLOCK(&helpers);
+
+	if (cli_is_registered(e)) {
+		ast_log(LOG_WARNING, "Command '%s' already registered (the same ast_cli_entry)\n",
+			S_OR(e->_full_cmd, e->command));
+		ret = 0;  /* report success */
+		goto done;
+	}
+
 	memset(&a, '\0', sizeof(a));
 	e->handler(e, CLI_INIT, &a);
 	/* XXX check that usage and command are filled up */
@@ -2085,14 +2112,16 @@
 	}
 	*dst++ = NULL;
 	
-	AST_RWLIST_WRLOCK(&helpers);
-	
 	if (find_cli(e->cmda, 1)) {
-		ast_log(LOG_WARNING, "Command '%s' already registered (or something close enough)\n", S_OR(e->_full_cmd, e->command));
+		ast_log(LOG_WARNING, "Command '%s' already registered (or something close enough)\n",
+			S_OR(e->_full_cmd, e->command));
 		goto done;
 	}
-	if (set_full_cmd(e))
+	if (set_full_cmd(e)) {
+		ast_log(LOG_WARNING, "Error registering CLI Command '%s'\n",
+			S_OR(e->_full_cmd, e->command));
 		goto done;
+	}
 
 	lf = e->cmdlen;
 	AST_RWLIST_TRAVERSE_SAFE_BEGIN(&helpers, cur, list) {
@@ -2112,6 +2141,10 @@
 
 done:
 	AST_RWLIST_UNLOCK(&helpers);
+	if (ret) {
+		ast_free(e->command);
+		e->command = NULL;
+	}
 
 	return ret;
 }
diff -uNrw asterisk-1.8.19.0/main/config.c asterisk-1.8.20.0-rc1/main/config.c
--- asterisk-1.8.19.0/main/config.c	2012-08-17 00:30:12.000000000 +0200
+++ asterisk-1.8.20.0-rc1/main/config.c	2012-12-03 20:29:17.000000000 +0100
@@ -32,7 +32,7 @@
 
 #include "asterisk.h"
 
-ASTERISK_FILE_VERSION(__FILE__, "$Revision: 371392 $")
+ASTERISK_FILE_VERSION(__FILE__, "$Revision: 377104 $")
 
 #include "asterisk/paths.h"	/* use ast_config_AST_CONFIG_DIR */
 #include "asterisk/network.h"	/* we do some sockaddr manipulation here */
@@ -2952,8 +2952,22 @@
 	AST_CLI_DEFINE(handle_cli_config_list, "Show all files that have loaded a configuration file"),
 };
 
+static void config_shutdown(void)
+{
+	struct cache_file_mtime *cfmtime;
+
+	AST_LIST_LOCK(&cfmtime_head);
+	while ((cfmtime = AST_LIST_REMOVE_HEAD(&cfmtime_head, list))) {
+		ast_free(cfmtime);
+	}
+	AST_LIST_UNLOCK(&cfmtime_head);
+
+	ast_cli_unregister_multiple(cli_config, ARRAY_LEN(cli_config));
+}
+
 int register_config_cli(void)
 {
 	ast_cli_register_multiple(cli_config, ARRAY_LEN(cli_config));
+	ast_register_atexit(config_shutdown);
 	return 0;
 }
